import { computed as p, ref as v, onMounted as he, openBlock as i, createElementBlock as r, normalizeClass as te, normalizeStyle as G, createVNode as B, createCommentVNode as y, createBlock as E, unref as d, createSlots as fe, withCtx as c, renderSlot as g, normalizeProps as O, guardReactiveProps as P, createElementVNode as n, Fragment as T, renderList as z, toDisplayString as m, createTextVNode as le, nextTick as ce } from "vue";
import { u as ge, c as pe, t as be, o as xe, e as me, X as we, s as ae, v as W, i as w, f as k, w as ke, x as _e, q as $e, r as Ce } from "./index-DVGMG23n.js";
import { t as Te, u as Le } from "./useResponsive-NZB-WLRF.js";
import { _ as Ae } from "./Title-DwQdoOA-.js";
import { u as Se, U as ze } from "./usePrinter-BuOMK1si.js";
import { _ as Ie } from "./Tooltip-2bIZhKpI.js";
import { D as Fe } from "./DataTable-C-fDolt7.js";
import Me from "./vue-ui-skeleton-0wzUlYHc.js";
import Oe from "./vue-ui-accordion-BlsYk-io.js";
import { u as oe } from "./useNestedProp-B0ThZBR4.js";
import { _ as Pe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ne = ["id"], Re = ["xmlns", "viewBox"], De = ["id"], Ge = ["stop-color"], Be = ["stop-color"], Ee = ["id"], We = ["stop-color"], Xe = ["stop-color"], Ue = ["x", "y", "width", "height", "fill", "rx"], Ve = ["x", "y", "width", "height", "fill", "rx"], Ye = ["x", "y", "width", "height", "fill", "rx"], je = ["x", "y", "width", "height", "fill", "rx"], He = { key: 0 }, qe = ["x", "y", "fill", "font-size", "font-weight"], Je = ["x", "y", "fill", "font-size", "font-weight"], Ke = { key: 1 }, Qe = ["x", "y", "font-size", "fill", "font-weight"], Ze = { key: 2 }, et = { key: 0 }, tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], lt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], at = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], ot = ["x", "y", "font-size", "fill", "font-weight"], st = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], it = ["x", "y", "font-size", "fill", "font-weight"], ut = ["x", "y", "font-size", "fill", "font-weight"], rt = ["x", "y", "width", "height", "fill", "onMouseover"], nt = {
  key: 3,
  class: "vue-data-ui-watermark"
}, dt = {
  __name: "vue-ui-age-pyramid",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(X, { expose: se }) {
    const f = X, { vue_ui_age_pyramid: ie } = ge(), I = p(() => !!f.dataset && f.dataset.length), b = v(pe()), ue = v(null), N = v(!1), R = v(""), F = v(null), U = v(0), L = v(null), V = v(null), e = p(() => {
      const t = oe({
        userConfig: f.config,
        defaultConfig: ie
      });
      return t.theme ? {
        ...oe({
          userConfig: be.vue_ui_age_pyramid[t.theme] || f.config,
          defaultConfig: t
        })
      } : t;
    }), Y = v(null);
    he(() => {
      if (xe(f.dataset) && me({
        componentName: "VueUiAgePyramid",
        type: "dataset"
      }), e.value.responsive) {
        const t = Te(() => {
          const { width: s, height: l } = Le({
            chart: L.value,
            title: e.value.style.title.text ? V.value : null
          });
          h.value.width = s, h.value.height = l;
        });
        Y.value = new ResizeObserver(t), Y.value.observe(L.value.parentNode);
      }
    });
    const { isPrinting: j, isImaging: H, generatePdf: q, generateImage: J } = Se({
      elementId: `vue-ui-age-pyramid_${b.value}`,
      fileName: e.value.style.title.text || "vue-ui-age-pyramid"
    }), x = v({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), h = v({
      height: e.value.style.height,
      width: e.value.style.width
    }), o = p(() => {
      const t = h.value.width - e.value.style.layout.padding.right - e.value.style.layout.padding.left, s = e.value.style.layout.padding.left, l = h.value.width - e.value.style.layout.padding.right;
      return {
        top: e.value.style.layout.padding.top,
        left: s,
        right: l,
        bottom: h.value.height - e.value.style.layout.padding.bottom,
        width: t,
        height: h.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom,
        centerX: e.value.style.layout.padding.left + t / 2,
        leftChart: {
          width: t / 2 - e.value.style.layout.centerSlit.width,
          right: s + t / 2 - e.value.style.layout.centerSlit.width
        },
        rightChart: {
          width: t / 2 - e.value.style.layout.centerSlit.width,
          left: s + t / 2 + e.value.style.layout.centerSlit.width
        }
      };
    }), re = p(() => f.dataset.map((t) => e.value.style.layout.dataLabels.yAxis.display === "age" ? t[1] : t[0])), _ = p(() => {
      const t = ne(A.value / 5), s = [], l = [];
      for (let a = 0; a <= 5; a += 1) {
        const u = t * a, ee = t * (a - 5);
        s.push({
          value: u,
          x: o.value.left + o.value.width / 2 + e.value.style.layout.centerSlit.width + u / A.value * o.value.leftChart.width
        }), l.push({
          value: Math.abs(ee),
          x: o.value.left + o.value.width / 2 + ee / A.value * o.value.leftChart.width - e.value.style.layout.centerSlit.width
        });
      }
      return {
        right: s,
        left: l
      };
    });
    function ne(t) {
      if (t === 0) return 0;
      const l = 10 ** Math.floor(Math.log10(Math.abs(t)));
      let a;
      return t < 0, a = Math.round(t / l) * l, a;
    }
    const A = p(() => Math.max(...f.dataset.flatMap((t) => t.slice(-2)))), $ = p(() => f.dataset.length), de = p(() => f.dataset.map((t) => ({
      segment: t[0],
      age: t[1],
      left: {
        value: t[2],
        proportionToMax: t[2] / A.value
      },
      right: {
        value: t[3],
        proportionToMax: t[3] / A.value
      }
    }))), C = p(() => de.value.map((t, s) => {
      const l = o.value.top + o.value.height / $.value * s, a = o.value.height / $.value - e.value.style.layout.bars.gap;
      return {
        segment: t.segment,
        age: t.age,
        left: {
          ...t.left,
          y: l,
          color: e.value.style.layout.bars.left.color,
          x: o.value.leftChart.right - t.left.proportionToMax * o.value.leftChart.width,
          width: t.left.proportionToMax * o.value.leftChart.width,
          height: a
        },
        right: {
          ...t.right,
          y: l,
          color: e.value.style.layout.bars.right.color,
          x: o.value.rightChart.left,
          width: t.right.proportionToMax * o.value.rightChart.width,
          height: a
        }
      };
    })), D = v(null);
    function ve(t, s) {
      F.value = t, D.value = {
        datapoint: s,
        seriesIndex: t,
        series: C.value,
        config: e.value
      };
      const l = e.value.style.tooltip.customFormat;
      if (ke(l) && _e(() => l({
        seriesIndex: t,
        datapoint: {
          segment: s[0],
          index: s[1],
          left: s[2],
          right: s[3]
        },
        series: C.value,
        config: e.value
      })))
        R.value = l({
          seriesIndex: t,
          datapoint: {
            segment: s[0],
            index: s[1],
            left: s[2],
            right: s[3]
          },
          series: C.value,
          config: e.value
        });
      else {
        let a = "";
        const u = C.value[t];
        a += `<div><b>${u.segment}</b></div>`, a += `<div>${e.value.translations.age}: ${w(
          e.value.style.layout.dataLabels.yAxis.formatter,
          u.age,
          k({ v: u.age }),
          { datapoint: s, seriesIndex: t }
        )}</div>`, a += `<div style="margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}">`, a += '<div style="display:flex; flex-direction:row;gap:12px">', a += `<div style="display:flex;flex-direction:column;align-items:center;justify-content:center"><svg viewBox="0 0 12 12" height="12" width="12"><rect stroke="none" x="0" y="0" height="12" width="12" rx="2" fill="${e.value.style.layout.bars.gradient.underlayer}"/><rect stroke="none" x="0" y="0" height="12" width="12" rx="2" fill="${e.value.style.layout.bars.gradient.show ? `url(#age_pyramid_left_${b.value})` : e.value.style.layout.bars.left.color}"/></svg><div>${e.value.translations.female}</div><div><b>${w(
          e.value.style.layout.dataLabels.xAxis.formatter,
          u.left.value,
          k({ v: u.left.value }),
          { datapoint: s, seriesIndex: t }
        )}</b></div></div>`, a += `<div style="display:flex;flex-direction:column;align-items:center;justify-content:center"><svg viewBox="0 0 12 12" height="12" width="12"><rect stroke="none" x="0" y="0" height="12" width="12" rx="2" fill="${e.value.style.layout.bars.gradient.underlayer}"/><rect stroke="none" x="0" y="0" height="12" width="12" rx="2" fill="${e.value.style.layout.bars.gradient.show ? `url(#age_pyramid_right_${b.value})` : e.value.style.layout.bars.right.color}"/></svg><div>${e.value.translations.male}</div><div><b>${w(
          e.value.style.layout.dataLabels.xAxis.formatter,
          u.right.value,
          k({ v: u.right.value }),
          { datapoint: s, seriesIndex: t }
        )}</b></div></div>`, a += "</div>", a += `<div style="margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}"><div>${e.value.translations.total}</div><div><b>${w(
          e.value.style.layout.dataLabels.xAxis.formatter,
          u.right.value + u.left.value,
          k({ v: u.right.value + u.left.value }),
          { datapoint: s, seriesIndex: t }
        )}</b></div></div>`, a += "</div>", R.value = `<div>${a}</div>`;
      }
      N.value = !0;
    }
    function K() {
      ce(() => {
        const t = [e.value.translations.year, e.value.translations.age, e.value.translations.female, e.value.translations.male, e.value.translations.total], s = f.dataset.map((u) => [
          u[0],
          u[1],
          u[2],
          u[3],
          u[2] + u[3]
        ]), l = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([t]).concat(s), a = $e(l);
        Ce({ csvContent: a, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const M = p(() => {
      const t = [
        e.value.translations.year,
        e.value.translations.age,
        e.value.translations.female,
        e.value.translations.male,
        e.value.translations.total
      ], s = f.dataset.map((a) => [
        a[0],
        a[1],
        a[2].toLocaleString(),
        a[3].toLocaleString(),
        (a[2] + a[3]).toLocaleString()
      ]), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: t, body: s, config: l, colNames: t };
    }), S = v(!1);
    function ye(t) {
      S.value = t, U.value += 1;
    }
    function Q() {
      x.value.showTable = !x.value.showTable;
    }
    function Z() {
      x.value.showTooltip = !x.value.showTooltip;
    }
    return se({
      generatePdf: q,
      generateCsv: K,
      generateImage: J,
      toggleTable: Q,
      toggleTooltip: Z
    }), (t, s) => (i(), r("div", {
      class: te(`vue-ui-age-pyramid ${S.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      ref_key: "agePyramid",
      ref: L,
      id: `vue-ui-age-pyramid_${b.value}`,
      style: G(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor};${e.value.responsive ? "height:100%" : ""}`)
    }, [
      e.value.style.title.text ? (i(), r("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: V,
        style: G(`width:100%;background:${e.value.style.backgroundColor}`)
      }, [
        B(Ae, {
          config: {
            title: {
              cy: "pyramid-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "pyramid-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : y("", !0),
      e.value.userOptions.show && I.value ? (i(), E(ze, {
        ref_key: "details",
        ref: ue,
        key: `user_options_${U.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: d(H),
        isPrinting: d(j),
        uid: b.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: S.value,
        isTooltip: x.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: L.value,
        onToggleFullscreen: ye,
        onGeneratePdf: d(q),
        onGenerateCsv: K,
        onGenerateImage: d(J),
        onToggleTable: Q,
        onToggleTooltip: Z
      }, fe({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: c(() => [
            g(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: c(() => [
            g(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: c(() => [
            g(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: c(() => [
            g(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: c(() => [
            g(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: c(({ toggleFullscreen: l, isFullscreen: a }) => [
            g(t.$slots, "optionFullscreen", O(P({ toggleFullscreen: l, isFullscreen: a })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      I.value ? (i(), r("svg", {
        key: 2,
        xmlns: d(we),
        class: te({ "vue-data-ui-fullscreen--on": S.value, "vue-data-ui-fulscreen--off": !S.value }),
        viewBox: `0 0 ${h.value.width <= 0 ? 10 : h.value.width} ${h.value.height <= 0 ? 10 : h.value.height}`,
        style: G(`max-width:100%;overflow:visible;background:${e.value.style.backgroundColor};color:${e.value.style.color}`)
      }, [
        n("defs", null, [
          n("linearGradient", {
            id: `age_pyramid_left_${b.value}`,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            n("stop", {
              offset: "0%",
              "stop-color": e.value.style.layout.bars.left.color
            }, null, 8, Ge),
            n("stop", {
              offset: "100%",
              "stop-color": `${d(ae)(e.value.style.layout.bars.left.color, e.value.style.layout.bars.gradient.shiftHue)}${d(W)[100 - e.value.style.layout.bars.gradient.intensity]}`
            }, null, 8, Be)
          ], 8, De),
          n("linearGradient", {
            id: `age_pyramid_right_${b.value}`,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            n("stop", {
              offset: "0%",
              "stop-color": `${d(ae)(e.value.style.layout.bars.right.color, e.value.style.layout.bars.gradient.shiftHue)}${d(W)[100 - e.value.style.layout.bars.gradient.intensity]}`
            }, null, 8, We),
            n("stop", {
              offset: "100%",
              "stop-color": e.value.style.layout.bars.right.color
            }, null, 8, Xe)
          ], 8, Ee)
        ]),
        (i(!0), r(T, null, z(C.value, (l, a) => (i(), r("g", null, [
          n("rect", {
            x: l.left.x,
            y: l.left.y,
            width: l.left.width <= 0 ? 1e-4 : l.left.width,
            height: l.left.height <= 0 ? 1e-4 : l.left.height,
            fill: e.value.style.layout.bars.gradient.underlayer,
            rx: e.value.style.layout.bars.borderRadius
          }, null, 8, Ue),
          n("rect", {
            x: l.left.x,
            y: l.left.y,
            width: l.left.width <= 0 ? 1e-4 : l.left.width,
            height: l.left.height <= 0 ? 1e-4 : l.left.height,
            fill: e.value.style.layout.bars.gradient.show ? `url(#age_pyramid_left_${b.value})` : l.left.color,
            rx: e.value.style.layout.bars.borderRadius
          }, null, 8, Ve),
          n("rect", {
            x: l.right.x,
            y: l.right.y,
            width: l.right.width <= 0 ? 1e-4 : l.right.width,
            height: l.right.height <= 0 ? 1e-4 : l.right.height,
            fill: e.value.style.layout.bars.gradient.underlayer,
            rx: e.value.style.layout.bars.borderRadius
          }, null, 8, Ye),
          n("rect", {
            x: l.right.x,
            y: l.right.y,
            width: l.right.width <= 0 ? 1e-4 : l.right.width,
            height: l.right.height <= 0 ? 1e-4 : l.right.height,
            fill: e.value.style.layout.bars.gradient.show ? `url(#age_pyramid_right_${b.value})` : l.right.color,
            rx: e.value.style.layout.bars.borderRadius
          }, null, 8, je)
        ]))), 256)),
        n("g", null, [
          e.value.style.layout.dataLabels.sideTitles.show ? (i(), r("g", He, [
            n("text", {
              x: o.value.left,
              y: o.value.top + e.value.style.layout.dataLabels.sideTitles.offsetY,
              fill: e.value.style.layout.dataLabels.sideTitles.useSideColor ? e.value.style.layout.bars.left.color : e.value.style.layout.dataLabels.sideTitles.color,
              "font-size": e.value.style.layout.dataLabels.sideTitles.fontSize,
              "text-anchor": "start",
              "font-weight": e.value.style.layout.dataLabels.sideTitles.bold ? "bold" : "normal"
            }, m(e.value.translations.female), 9, qe),
            n("text", {
              x: o.value.right,
              y: o.value.top + e.value.style.layout.dataLabels.sideTitles.offsetY,
              fill: e.value.style.layout.dataLabels.sideTitles.useSideColor ? e.value.style.layout.bars.right.color : e.value.style.layout.dataLabels.sideTitles.color,
              "font-size": e.value.style.layout.dataLabels.sideTitles.fontSize,
              "text-anchor": "end",
              "font-weight": e.value.style.layout.dataLabels.sideTitles.bold ? "bold" : "normal"
            }, m(e.value.translations.male), 9, Je)
          ])) : y("", !0),
          e.value.style.layout.dataLabels.yAxis.show ? (i(), r("g", Ke, [
            (i(!0), r(T, null, z(re.value, (l, a) => (i(), r(T, null, [
              a % e.value.style.layout.dataLabels.yAxis.showEvery === 0 ? (i(), r("text", {
                key: 0,
                x: o.value.centerX,
                y: o.value.top + o.value.height / $.value * a + e.value.style.layout.dataLabels.yAxis.fontSize / 3,
                "text-anchor": "middle",
                "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
                fill: e.value.style.layout.dataLabels.yAxis.color,
                "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal"
              }, m(d(w)(
                e.value.style.layout.dataLabels.yAxis.formatter,
                l,
                d(k)({ v: l }),
                { datapoint: l, seriesIndex: a }
              )), 9, Qe)) : y("", !0)
            ], 64))), 256))
          ])) : y("", !0),
          e.value.style.layout.dataLabels.xAxis.show ? (i(), r("g", Ze, [
            e.value.style.layout.grid.show ? (i(), r("g", et, [
              n("line", {
                x1: _.value.right[0].x,
                x2: _.value.right.at(-1).x,
                y1: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 2,
                y2: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 2,
                stroke: e.value.style.layout.grid.stroke,
                "stroke-width": e.value.style.layout.grid.strokeWidth,
                "stroke-linecap": "round"
              }, null, 8, tt),
              n("line", {
                x1: _.value.left[0].x,
                x2: _.value.left.at(-1).x,
                y1: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 2,
                y2: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 2,
                stroke: e.value.style.layout.grid.stroke,
                "stroke-width": e.value.style.layout.grid.strokeWidth,
                "stroke-linecap": "round"
              }, null, 8, lt)
            ])) : y("", !0),
            (i(!0), r(T, null, z(_.value.right, (l, a) => (i(), r("g", null, [
              e.value.style.layout.grid.show ? (i(), r("line", {
                key: 0,
                x1: l.x,
                x2: l.x,
                y1: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 2,
                y2: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 4,
                stroke: e.value.style.layout.grid.stroke,
                "stroke-width": e.value.style.layout.grid.strokeWidth,
                "stroke-linecap": "round"
              }, null, 8, at)) : y("", !0),
              n("text", {
                x: l.x,
                y: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize * 2,
                "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
                fill: e.value.style.layout.dataLabels.xAxis.color,
                "text-anchor": "middle",
                "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal"
              }, m(d(w)(
                e.value.style.layout.dataLabels.xAxis.formatter,
                l.value / e.value.style.layout.dataLabels.xAxis.scale,
                d(k)({
                  v: l.value / e.value.style.layout.dataLabels.xAxis.scale
                }),
                { datapoint: l, seriesIndex: a }
              )), 9, ot)
            ]))), 256)),
            (i(!0), r(T, null, z(_.value.left, (l, a) => (i(), r("g", null, [
              e.value.style.layout.grid.show ? (i(), r("line", {
                key: 0,
                x1: l.x,
                x2: l.x,
                y1: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 2,
                y2: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize / 4,
                stroke: e.value.style.layout.grid.stroke,
                "stroke-width": e.value.style.layout.grid.strokeWidth,
                "stroke-linecap": "round"
              }, null, 8, st)) : y("", !0),
              n("text", {
                x: l.x,
                y: o.value.bottom + e.value.style.layout.dataLabels.xAxis.fontSize * 2,
                "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
                fill: e.value.style.layout.dataLabels.xAxis.color,
                "text-anchor": "middle",
                "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal"
              }, m(d(w)(
                e.value.style.layout.dataLabels.xAxis.formatter,
                l.value / e.value.style.layout.dataLabels.xAxis.scale,
                d(k)({
                  v: l.value / e.value.style.layout.dataLabels.xAxis.scale
                }),
                { datapoint: l, seriesIndex: a }
              )), 9, it)
            ]))), 256)),
            n("text", {
              x: o.value.right,
              y: h.value.height,
              "text-anchor": "end",
              "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
              fill: e.value.style.layout.dataLabels.xAxis.color,
              "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal"
            }, m(e.value.style.layout.dataLabels.xAxis.translation), 9, ut)
          ])) : y("", !0)
        ]),
        (i(!0), r(T, null, z(X.dataset, (l, a) => (i(), r("g", null, [
          n("rect", {
            x: o.value.left,
            y: o.value.top + o.value.height / $.value * a - e.value.style.layout.bars.gap / 2,
            width: o.value.width <= 0 ? 1e-4 : o.value.width,
            height: o.value.height / $.value <= 0 ? 1e-4 : o.value.height / $.value,
            fill: F.value !== null && F.value === a ? `${e.value.style.highlighter.color}${d(W)[e.value.style.highlighter.opacity]}` : "transparent",
            onMouseover: (u) => ve(a, l),
            onMouseleave: s[0] || (s[0] = (u) => {
              F.value = null, N.value = !1;
            })
          }, null, 40, rt)
        ]))), 256)),
        g(t.$slots, "svg", { svg: h.value }, void 0, !0)
      ], 14, Re)) : y("", !0),
      t.$slots.watermark ? (i(), r("div", nt, [
        g(t.$slots, "watermark", O(P({ isPrinting: d(j) || d(H) })), void 0, !0)
      ])) : y("", !0),
      I.value ? y("", !0) : (i(), E(Me, {
        key: 4,
        config: {
          type: "pyramid",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            pyramid: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      g(t.$slots, "legend", { legend: C.value }, void 0, !0),
      B(Ie, {
        show: x.value.showTooltip && N.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: L.value,
        content: R.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": c(() => [
          g(t.$slots, "tooltip-before", O(P({ ...D.value })), void 0, !0)
        ]),
        "tooltip-after": c(() => [
          g(t.$slots, "tooltip-after", O(P({ ...D.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      I.value ? (i(), E(Oe, {
        key: 5,
        hideDetails: "",
        config: {
          open: x.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: c(() => [
          B(Fe, {
            colNames: M.value.colNames,
            head: M.value.head,
            body: M.value.body,
            config: M.value.config,
            title: `${e.value.style.title.text}${e.value.style.title.subtitle.text ? ` : ${e.value.style.title.subtitle.text}` : ""}`,
            onClose: s[1] || (s[1] = (l) => x.value.showTable = !1)
          }, {
            th: c(({ th: l }) => [
              le(m(l), 1)
            ]),
            td: c(({ td: l }) => [
              le(m(l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 14, Ne));
  }
}, kt = /* @__PURE__ */ Pe(dt, [["__scopeId", "data-v-2386706e"]]);
export {
  kt as default
};
