import { computed as f, onMounted as Te, ref as k, openBlock as r, createElementBlock as v, normalizeClass as ne, normalizeStyle as w, createVNode as se, createCommentVNode as N, createBlock as G, unref as h, createSlots as Pe, withCtx as b, renderSlot as C, normalizeProps as ue, guardReactiveProps as re, createElementVNode as O, Fragment as T, renderList as P, toDisplayString as B, createTextVNode as Fe, nextTick as Ie } from "vue";
import { u as Le, o as He, e as Oe, c as ie, t as Ee, a as Me, p as A, b as Se, f as ce, X as ze, D as de, F as Ye, i as De, q as Ge, r as Be } from "./index-DVGMG23n.js";
import { _ as Ae } from "./Title-DwQdoOA-.js";
import { u as Ue, U as Ve } from "./usePrinter-BuOMK1si.js";
import { D as je } from "./DataTable-C-fDolt7.js";
import Xe from "./vue-ui-accordion-BlsYk-io.js";
import We from "./vue-ui-skeleton-0wzUlYHc.js";
import { u as ve } from "./useNestedProp-B0ThZBR4.js";
import { _ as qe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Re = ["id"], Ze = ["xmlns", "viewBox"], Je = ["id"], Ke = ["stop-color"], Qe = ["stop-color"], et = ["d", "fill", "stroke", "stroke-width"], tt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "onMouseenter"], lt = ["x", "y", "font-size", "fill"], ot = ["x", "y", "font-size", "fill"], at = {
  key: 2,
  class: "vue-data-ui-watermark"
}, nt = ["innerHTML"], st = {
  __name: "vue-ui-flow",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(fe, { expose: he }) {
    const m = fe, { vue_ui_flow: me } = Le(), E = f(() => !!m.dataset && m.dataset.length);
    Te(() => {
      He(m.dataset) && Oe({
        componentName: "VueUiFlow",
        type: "dataset"
      });
    });
    const M = k(ie()), U = k(null), V = k(0), _ = k(!1);
    function ge(l) {
      _.value = l, V.value += 1;
    }
    const e = f(() => {
      const l = ve({
        userConfig: m.config,
        defaultConfig: me
      });
      return l.theme ? {
        ...ve({
          userConfig: Ee.vue_ui_flow[l.theme] || m.config,
          defaultConfig: l
        }),
        customPalette: Me[l.theme] || A
      } : l;
    }), { isPrinting: j, isImaging: X, generatePdf: W, generateImage: q } = Ue({
      elementId: `flow_${M.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-flow"
    }), S = f(() => Se(e.value.customPalette)), R = f(() => e.value.style.chart.nodes.gap), x = f(() => e.value.style.chart.nodes.width), F = k({
      showTable: e.value.table.show
    }), Z = f(() => e.value.style.chart.links.width), J = f(() => {
      const l = {};
      function o(n) {
        l[n] || (l[n] = { inflow: 0, outflow: 0 });
      }
      m.dataset.forEach(([n, a, i]) => {
        o(n), o(a), l[n].outflow += i, l[a].inflow += i;
      });
      let t = 0;
      for (const n in l) {
        const a = Math.max(l[n].inflow, l[n].outflow);
        t = Math.max(t, a);
      }
      return t;
    });
    function pe(l) {
      return l / J.value * 100 + e.value.style.chart.nodes.minHeight;
    }
    function be(l) {
      const o = e.value.style.chart.nodes.minHeight;
      return (l - o) / 100 * J.value;
    }
    function ye(l) {
      const o = {}, t = {};
      function n(s, u) {
        o[s] || (o[s] = { height: 0, level: null, inflow: 0, outflow: 0 }), o[s].level === null && (o[s].level = u), t[u] || (t[u] = []), t[u].includes(s) || t[u].push(s);
      }
      l.forEach(([s, u, c], $) => {
        const y = o[s] ? o[s].level : 0, H = y + 1;
        n(s, y), n(u, H), o[s].children || (o[s].children = []), o[s].children.push({ target: u, value: c }), o[s].outflow += c, o[u].inflow += c;
      }), Object.keys(o).forEach((s, u) => {
        o[s].color = S.value[u] || S.value[u % S.value.length] || A[u] || A[u % d.length];
      });
      for (const s in o)
        o[s].height = pe(Math.max(o[s].inflow, o[s].outflow)), o[s].name = s;
      const a = {};
      for (const s in t) {
        let u = 0;
        t[s].forEach((c, $) => {
          const y = o[c].height;
          a[c] = {
            x: parseInt(s, 10) * Z.value + e.value.style.chart.padding.left,
            y: u,
            absoluteY: u,
            height: y,
            i: $,
            color: o[c].color,
            value: be(y)
          }, u += y + R.value;
        });
      }
      const i = [];
      for (const s in o) {
        let u = a[s].absoluteY;
        o[s].children && o[s].children.forEach(({ target: c, value: $ }, y) => {
          const H = a[c].y, Y = a[s], D = a[c], te = u, le = u + $ / o[s].outflow * Y.height, oe = H, ae = H + $ / o[c].inflow * D.height, Ne = {
            id: ie(),
            source: s,
            target: c,
            path: `M ${Y.x + x.value} ${te} L ${Y.x + x.value} ${le} L ${D.x} ${ae} L ${D.x} ${oe} Z`,
            value: $,
            sourceColor: o[s].color,
            targetColor: o[c].color
          };
          i.push(Ne), u += le - te, a[c].y += ae - oe;
        });
      }
      return { nodeCoordinates: a, links: i };
    }
    const g = f(() => {
      const l = ye(m.dataset);
      return {
        nodes: Object.keys(l.nodeCoordinates).map((o, t) => ({
          ...l.nodeCoordinates[o],
          name: o
        })),
        links: l.links
      };
    }), ke = f(() => we(g.value.nodes));
    function we(l) {
      const o = {};
      for (const n in l) {
        const { x: a, height: i } = l[n];
        o[a] || (o[a] = 0), o[a] += i + R.value;
      }
      return Math.max(...Object.values(o));
    }
    const z = f(() => {
      const { top: l, right: o, left: t, bottom: n } = e.value.style.chart.padding, a = m.dataset.length * Z.value;
      return {
        height: ke.value + l + n,
        width: o + Math.max(...g.value.nodes.map((i) => i.x)) + x.value,
        left: t,
        top: l,
        right: a - o,
        p_top: l,
        p_bottom: n
      };
    });
    function Ce(l) {
      const o = {}, t = {}, n = /* @__PURE__ */ new Set();
      return m.dataset.forEach(([a, i, s]) => {
        o[a] || (o[a] = []), t[i] || (t[i] = []), o[a].push(i), t[i].push(a);
      }), o[l] && o[l].forEach((a) => n.add(a)), t[l] && t[l].forEach((a) => n.add(a)), Array.from(n).concat(l);
    }
    const p = k(null), I = k(null);
    function xe(l) {
      p.value = Ce(l.name), I.value = l.name;
    }
    function $e() {
      p.value = null, I.value = null;
    }
    const K = f(() => g.value.links.map(({ source: l, target: o, sourceColor: t, targetColor: n, value: a }) => ({
      source: l,
      target: o,
      sourceColor: t,
      targetColor: n,
      value: a
    })));
    function Q() {
      Ie(() => {
        const l = K.value.map((n, a) => [
          [n.source],
          [n.target],
          [n.value]
        ]), o = [
          [e.value.style.chart.title.text],
          [e.value.style.chart.title.subtitle.text],
          [
            [e.value.table.columnNames.source],
            [e.value.table.columnNames.target],
            [e.value.table.columnNames.value]
          ]
        ].concat(l), t = Ge(o);
        Be({
          csvContent: t,
          title: e.value.style.chart.title.text || "vue-ui-flow"
        });
      });
    }
    const L = f(() => {
      const l = [
        e.value.table.columnNames.source,
        e.value.table.columnNames.target,
        e.value.table.columnNames.value
      ], o = K.value.map((a, i) => [
        {
          color: a.sourceColor,
          name: a.source
        },
        {
          color: a.targetColor,
          name: a.target
        },
        ce({
          p: e.value.style.chart.nodes.labels.prefix,
          v: a.value,
          s: e.value.style.chart.nodes.labels.suffix,
          r: e.value.style.chart.nodes.labels.rounding
        })
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.source,
          e.value.table.columnNames.target,
          e.value.table.columnNames.value
        ],
        head: l,
        body: o,
        config: t
      };
    });
    function _e() {
      return g.value;
    }
    function ee() {
      F.value.showTable = !F.value.showTable;
    }
    return he({
      getData: _e,
      generateCsv: Q,
      generateImage: q,
      generatePdf: W,
      toggleTable: ee
    }), (l, o) => (r(), v("div", {
      ref_key: "flowChart",
      ref: U,
      class: ne(`vue-ui-flow ${_.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: w(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `flow_${M.value}`
    }, [
      e.value.style.chart.title.text ? (r(), v("div", {
        key: 0,
        style: w(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:24px`)
      }, [
        se(Ae, {
          config: {
            title: {
              cy: "flow-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "flow-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : N("", !0),
      e.value.userOptions.show && E.value ? (r(), G(Ve, {
        ref: "details",
        key: `user_option_${V.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: h(j),
        isImaging: h(X),
        uid: M.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: _.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: U.value,
        onToggleFullscreen: ge,
        onGeneratePdf: h(W),
        onGenerateCsv: Q,
        onGenerateImage: h(q),
        onToggleTable: ee
      }, Pe({ _: 2 }, [
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: b(() => [
            C(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: b(() => [
            C(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: b(() => [
            C(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: b(() => [
            C(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: b(({ toggleFullscreen: t, isFullscreen: n }) => [
            C(l.$slots, "optionFullscreen", ue(re({ toggleFullscreen: t, isFullscreen: n })), void 0, !0)
          ]),
          key: "4"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : N("", !0),
      (r(), v("svg", {
        xmlns: h(ze),
        viewBox: `0 0 ${z.value.width} ${z.value.height}`,
        class: ne({ "vue-data-ui-fullscreen--on": _.value, "vue-data-ui-fulscreen--off": !_.value }),
        style: w(`max-width:100%; overflow: visible; background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        O("defs", null, [
          (r(!0), v(T, null, P(g.value.links, (t, n) => (r(), v("linearGradient", {
            id: t.id,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            O("stop", {
              offset: "0%",
              "stop-color": t.sourceColor
            }, null, 8, Ke),
            O("stop", {
              offset: "100%",
              "stop-color": t.targetColor
            }, null, 8, Qe)
          ], 8, Je))), 256))
        ]),
        (r(!0), v(T, null, P(g.value.links, (t) => (r(), v("path", {
          class: "vue-ui-flow-link",
          d: t.path,
          fill: `url(#${t.id})`,
          stroke: e.value.style.chart.links.stroke,
          "stroke-width": e.value.style.chart.links.strokeWidth,
          style: w(`opacity:${I.value ? [t.target, t.source].includes(I.value) ? 1 : 0.3 : e.value.style.chart.links.opacity}`)
        }, null, 12, et))), 256)),
        (r(!0), v(T, null, P(g.value.nodes, (t, n) => (r(), v("rect", {
          class: "vue-ui-flow-node",
          x: t.x,
          y: t.absoluteY,
          height: t.height,
          width: x.value,
          fill: t.color,
          stroke: e.value.style.chart.nodes.stroke,
          "stroke-width": e.value.style.chart.nodes.strokeWidth,
          onMouseenter: (a) => xe(t),
          onMouseleave: o[0] || (o[0] = (a) => $e()),
          style: w(`opacity:${p.value ? p.value.includes(t.name) ? 1 : 0.2 : 1}`)
        }, null, 44, tt))), 256)),
        (r(!0), v(T, null, P(g.value.nodes, (t, n) => (r(), v("text", {
          x: t.x + x.value / 2,
          y: t.absoluteY + t.height / 2 - e.value.style.chart.nodes.labels.fontSize / 4,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: h(de)(t.color),
          "text-anchor": "middle",
          style: w(`pointer-events: none; opacity:${p.value ? p.value.includes(t.name) ? 1 : 0 : 1}`)
        }, B(e.value.style.chart.nodes.labels.abbreviation.use ? h(Ye)({ source: t.name, length: e.value.style.chart.nodes.labels.abbreviation.length }) : t.name), 13, lt))), 256)),
        (r(!0), v(T, null, P(g.value.nodes, (t, n) => (r(), v("text", {
          x: t.x + x.value / 2,
          y: t.absoluteY + t.height / 2 + e.value.style.chart.nodes.labels.fontSize,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: h(de)(t.color),
          "text-anchor": "middle",
          style: w(`pointer-events: none; opacity:${p.value ? p.value.includes(t.name) ? 1 : 0 : 1}`)
        }, B(h(De)(
          e.value.style.chart.nodes.labels.formatter,
          t.value,
          h(ce)({
            p: e.value.style.chart.nodes.labels.prefix,
            v: t.value,
            s: e.value.style.chart.nodes.labels.suffix,
            r: e.value.style.chart.nodes.labels.rounding
          }),
          { datapoint: t, seriesIndex: n }
        )), 13, ot))), 256)),
        C(l.$slots, "svg", { svg: z.value }, void 0, !0)
      ], 14, Ze)),
      l.$slots.watermark ? (r(), v("div", at, [
        C(l.$slots, "watermark", ue(re({ isPrinting: h(j) || h(X) })), void 0, !0)
      ])) : N("", !0),
      E.value ? N("", !0) : (r(), G(We, {
        key: 3,
        config: {
          type: "flow",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      E.value ? (r(), G(Xe, {
        key: 4,
        hideDetails: "",
        config: {
          open: F.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: b(() => [
          se(je, {
            colNames: L.value.colNames,
            head: L.value.head,
            body: L.value.body,
            config: L.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[1] || (o[1] = (t) => F.value.showTable = !1)
          }, {
            th: b(({ th: t }) => [
              O("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, nt)
            ]),
            td: b(({ td: t }) => [
              Fe(B(t.name || t), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : N("", !0)
    ], 14, Re));
  }
}, gt = /* @__PURE__ */ qe(st, [["__scopeId", "data-v-2f88276e"]]);
export {
  gt as default
};
